#include <imsls.h>
#include <stdio.h>
extern FILE* imsls_fopen(char* filename, char* mode);
extern void imsls_fclose(FILE* file);

int main()
{
   FILE *file;
   char *filename = "NB_Classifier_Ex2.txt";
   int i, j;
   int n_patterns    =150; /* 150 training patterns            */
   int n_cont4       =4;   /* four continuous input attributes */
   int n_cont2       =2;   /* two continuous input attributes  */
   int n_classes     =3;   /* three classification categories  */
   int n_classifiers =2;   /* two classifiers in this example  */
   int classification[150], *classErrors;
   float cont4[4*150], cont2[2*150] ;
   float *irisData;       /* Fishers Iris Data */
   char *classLabel[3] = {"Setosa     ", "Versicolour", "Virginica  "};
   Imsls_f_nb_classifier *nb_classifier;
   irisData = imsls_f_data_sets(3,0);

   /* setup the required input arrays from the data matrix */
   for(i=0; i<n_patterns; i++){
      classification[i] = (int) irisData[i*5]-1;
      for(j=1; j<=n_cont4; j++) {
         cont4[i*n_cont4+j-1] = irisData[i*5+j];
         if(j<3) cont2[i*n_cont2+j-1] = irisData[i*5+j];
      }
   }
   printf("Opening file %s\n\n", filename);
   file = imsls_fopen(filename, "w");
   fprintf(file, "%d\n", 2);
   classErrors = imsls_f_naive_bayes_trainer(n_patterns, 
      n_classes, classification, 
      IMSLS_CONTINUOUS, n_cont4, cont4,
      IMSLS_NB_CLASSIFIER, &nb_classifier, 0);

   printf("Iris Classification Error Rates - Classifier 1\n");
   printf("----------------------------------------------\n");
   printf("   Setosa  Versicolour  Virginica   |   TOTAL\n");
   printf("    %d/%d      %d/%d         %d/%d     |   %d/%d\n", 
      classErrors[0], classErrors[1],
      classErrors[2], classErrors[3],
      classErrors[4], classErrors[5],
      classErrors[6], classErrors[7]);
   printf("----------------------------------------------\n\n");
   imsls_free(classErrors);
   /* write first classifier */
   imsls_f_nb_classifier_write(nb_classifier, NULL, IMSLS_PRINT, 
      IMSLS_FILE, file, 0);

   imsls_f_nb_classifier_free(nb_classifier);
   classErrors = imsls_f_naive_bayes_trainer(n_patterns, 
      n_classes, classification, 
      IMSLS_CONTINUOUS, n_cont2, cont2, 
      IMSLS_NB_CLASSIFIER, &nb_classifier, 0);
   printf("Iris Classification Error Rates - Classifier 2\n");
   printf("----------------------------------------------\n");
   printf("   Setosa  Versicolour  Virginica   |   TOTAL\n");
   printf("    %d/%d      %d/%d       %d/%d     |   %d/%d\n", 
      classErrors[0], classErrors[1],
      classErrors[2], classErrors[3],
      classErrors[4], classErrors[5],
      classErrors[6], classErrors[7]);
   printf("----------------------------------------------\n\n");
   imsls_f_nb_classifier_write(nb_classifier, NULL, IMSLS_PRINT, 
      IMSLS_FILE, file, 0);
   imsls_free(classErrors);
   printf("Closing Classifier File\n");
   imsls_fclose(file);

   return;
}
